<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import { useCreateStore } from '@/stores/create';
import { itemEnum } from '@/enums/enums';
import BoxSelector from '../general/form/BoxSelector.vue';
import Checkbox from "../general/form/Checkbox.vue";
import Switch from "../general/form/Switch.vue";
import Button from '../general/Button.vue';

const { t } = useI18n();
const $t = t;

const createStore = useCreateStore();
const { allowLikes, likeIcon, elementShape, fontSize, activePage, columnWidth, type, font, columnAddPosition, elementWidth } = storeToRefs(createStore);
let configuration = inject<any>('configuration');
const likeSymbols = configuration.style.likeSymbols;
const shapes = configuration.style.shapes;
const fontSizes = configuration.style.fontSizes;
const columnWidths = configuration.style.columnWidths;

const setActivePage = (value: string) => {
    activePage.value = value;
}

const localColumnAddPosition = computed({
    get() {
        return columnAddPosition.value === "bottom";
    },
    set(value: boolean) {
        columnAddPosition.value = value ? "bottom" : "top";
    }
});

</script>
<template>
    <div class="flex flex-col h-full justify-between">
        <div class="flex flex-row w-full">
        <div :class="[type === 'Schedule' ? 'sm:w-1/3' : 'sm:w-3/5']">
            <div class="p-2">
                <Checkbox :label="$t('adjustPanel.general.true')" v-model="allowLikes"
                    :header="$t('adjustPanel.general.likes')" />
                <BoxSelector :label="$t('adjustPanel.general.likeSymbol')" v-model="likeIcon" v-show="allowLikes"
                    :items="likeSymbols" :identifier="itemEnum.NAME" type="icons" />
                <BoxSelector :label="$t('adjustPanel.general.shape')" v-model="elementShape" :items="shapes"
                    :identifier="itemEnum.ID" type="shapes" />
                <BoxSelector :label="$t('adjustPanel.general.fontsize')" v-model="fontSize" :items="fontSizes"
                    :identifier="itemEnum.VALUE" type="fontSize" />
                <BoxSelector :label="$t('adjustPanel.general.columnwidth')" v-model="columnWidth" :items="columnWidths"
                    :identifier="itemEnum.VALUE" type="fontSize" v-if="type === 'Schedule'" />
                <BoxSelector :label="$t('adjustPanel.general.elementwidth')" v-model="elementWidth"
                    :items="columnWidths" :identifier="itemEnum.VALUE" type="fontSize" v-if="type === 'Timeline'" />
                <Switch v-model="localColumnAddPosition" :leftLabel="$t('adjustPanel.general.newElementPosition.top')"
                    :label="$t('adjustPanel.general.newElementPosition.bottom')"
                    :header="$t('adjustPanel.general.newElementPosition.label')"
                    v-if="type !== 'Freeform' && type !== 'Timeline'" />
                <label>{{ $t('adjustPanel.general.fontFamily') }}</label>
                <select
                    class="w-full border border-gray-300 px-2 py-1.5 focus:border-accent1-default rounded-md focus-visible:outline-0"
                    v-model="font">
                    <option value="default">Standard</option>
                    <option value="arial" class="arial">Arial</option>
                    <option value="comic-neue" class="comic-neue">Comic Neue</option>
                    <option value="courier" class="courier">Courier</option>
                    <option value="georgia" class="georgia">Georgia</option>
                    <option value="helvetica" class="helvetica">Helvetica</option>
                    <option value="times-new-roman" class="times-new-roman">Times New Roman</option>
                    <option value="trebuchet-ms" class="trebuchet-ms">Trebuchet-MS</option>
                    <option value="verdana" class="verdana">Verdana</option>
                </select>
            </div>
        </div>
        <div :class="[type === 'Schedule' ? 'sm:w-2/3' : 'sm:w-2/5']"
            class="p-4 pt-0 h-[330px] w-full">
            <h5 class="text-center mb-4 text-xl">{{ $t('create.preview') }}</h5>
            <div :class="['w-full relative box-border transition duration-100 ease-in-out rounded-lg p-2 h-32', font]">
                <div class="border border-black h-20 p-4 relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md mx-auto max-w-full"
                    :class="[elementShape, fontSize]"
                    :style="{ width: (type === 'Schedule' ? columnWidth + 'px!important' : '150px') }">
                    <span>{{ $t('placeholder.text') }}</span>
                    <div class="absolute -bottom-1 left-1 text-[24px]" v-show="allowLikes"><i :class="[`ri-${likeIcon}-line`]"></i></div>
                </div>
            </div>
        </div>
    </div>
        <div class="flex flex-row w-full justify-between">
            <div>
                <Button variant="cancel" @click="setActivePage('important')">
                    <i class="ri-arrow-left-s-line"></i>
                    <span class="uppercase">{{ $t('general.buttons.back') }}</span>
                </Button>
            </div>
            <div>
                <Button variant="confirm" @click="setActivePage('color')">
                    <span class="uppercase">{{ $t('general.buttons.next') }}</span>
                    <i class="ri-arrow-right-s-line"></i>
                </Button>
            </div>
        </div>
    </div>
</template>
